#include <stdio.h>
#include <stdlib.h>
#include "common.h"
#include "fatal.h"
#include "expr_types.h"
#include "eval.h"
#include "parser.h"
#include "param_types.h"
#include "param.h"
#include "func_types.h"
#include "func.h"
#include "preset_types.h"
#include "preset.h"
#include "per_pixel_eqn.h"
int main(int argc, char * argv[]) {

  int i, j;
	int n = 0;
	char c;
	int flag = 1;
	if (argc < 2)
		return 0;
  /* In this case, load a specific file */
  if (!strncmp(argv[1], "-f", 2)) {
	  if (argc < 3) {
		  printf("Missing preset file name for -f option\n");
		  return -1;
	  }
		  
	initPresetLoader();
	 	  
	 if (loadPresetByFile(argv[2]) < 0) {
		 printf("Bad file name for preset: \"%s\"\n", argv[2]);
		 destroyPresetLoader();
		 return -1;
	 }
	
	 /* Evaluate initial per frames??? */
	 
	/* Evaluate the per frame equations */	 
	  evalPerFrameEquations();
	  
	/* Evaluate all per pixel equations */
	  for (j = 0; j < NUM_OPS;j++) {
		if (isPerPixelEqn(j))
			evalPerPixelEqn(j, 1, 1, 1, 1);		
  		}	    
  	 /* Finished */
	destroyPresetLoader();
	printf("*** Debug for file \"%s\" finished ***\n", argv[2]);
	return 0;
  }
	  
  if (argc == 3)
	n = atoi(argv[2]);
  	
  
  initPresetLoader(); 
  if (loadPresetDir(argv[1]) < 0) {
    printf("BAD DIRECTORY SPECIFIED!\n");
    destroyPresetLoader();
    return -1;    
  }

  evalPerFrameEquations();
  
  for (j = 0; j < NUM_OPS;j++) {
	if (isPerPixelEqn(j))
		evalPerPixelEqn(j, 1, 1, 1, 1);		
  }	    
  
  for (i=0; i < (n-1);i++) {
	  if (switchPreset(ALPHA_NEXT, HARD_CUT) >= 0) {
  	  evalPerFrameEquations();
	  
	  for (j = 0; j < NUM_OPS;j++) {
		if (isPerPixelEqn(j))
			evalPerPixelEqn(j, 1, 1, 1, 1);		
  		}	    
  	  } else {
	    printf("COULDN'T SWITCH TO NEXT PRESET!\n");
	    closePresetDir();
	    destroyPresetLoader();
	    return -1;
	  }
  }	  
  
  printf("DEBUG FINISHED, CLOSING...\n");
  closePresetDir();
  destroyPresetLoader();
  return 0;
}
